variables:
  DOCKER_HOST: tcp://docker:2375
  MOUNT_POINT: "/builds/$CI_PROJECT_PATH/mnt"
  CONTAINER_IMAGE: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"
  SECURE_LOG_LEVEL: debug
  NAMESPACE: stable-diffusion

stages:
  - build
  - test
  - review
  - deploy

build-ui-image:
  stage: build
  image:
    name:  gcr.io/kaniko-project/executor:debug
    entrypoint:
    - ''
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}"
      > /kaniko/.docker/config.json
    - "/kaniko/executor  --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile
      --destination $CONTAINER_IMAGE"
    #- echo "Current CONTAINER_IMAGE"
    #- echo $CONTAINER_IMAGE
  
    #- echo "UPSTREAM_CONTAINER_IMAGE=$CONTAINER_IMAGE" >> containerimage.env
    #- echo "UPSTREAM_IMAGE_TAG=$CI_COMMIT_SHA" >> containerimage.env
    #- echo "UPSTREAM_CI_COMMIT_SHORT=$CI_COMMIT_SHORT_SHA" >> containerimage.env
    #- echo "UPSTREAM_CI_ENV_SLUG=$CI_ENVIRONMENT_SLUG" >> containerimage.env

  #artifacts:
    #reports:
      #dotenv: containerimage.env


#test-image-health:
  #stage: test
  #image:
    #name: $CONTAINER_IMAGE
  #script:
    #- echo $UPSTREAM_IMAGE_TAG
    #- docker run -d -p 8501:8501 $CONTAINER_IMAGE
    #- pytest tests/

  #allow_failure: true

  only:
    - branches

  except:
    - main 

deploy_review:
  image: crileroro/gcloud-kubectl-helm
  stage: review
  script:
    - kubectl config use-context tech-marketing/devops-platform-use-cases/stable-diffusion:gpu-agent
    - kubectl create ns $NAMESPACE-$CI_ENVIRONMENT_SLUG --dry-run=client -o yaml | kubectl apply -f -
    - helm upgrade -i review-$CI_COMMIT_SHORT_SHA review-ml-app --namespace $NAMESPACE-$CI_ENVIRONMENT_SLUG --set ingress.host=$CI_ENVIRONMENT_SLUG.34.172.88.126.nip.io --set image.repository=$CONTAINER_IMAGE


  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$CI_ENVIRONMENT_SLUG.34.172.88.126.nip.io
  only:
    - branches
  except:
    - main 


